import json
import random

def listsum(input):
    return sum(sum(row) for row in input)

def mazegenerate(sizex, sizey):
    Walls = [[[1, 1, 1, 1] for _ in range(sizex)] for _ in range(sizey)]
    x, y = 0, 0
    visitsum = 0
    currentnode = [x, y]
    visited = [[0 for _ in range(sizex)] for _ in range(sizey)]
    visited[y][x] = 1
    visitn = [[x, y]]
    n = 0

    while visitsum != (sizex * sizey):
        options = [0, 0, 0, 0]
        if x != 0 and visited[y][x - 1] == 0:
            options[0] = 1
        if y != sizey - 1 and visited[y + 1][x] == 0:
            options[1] = 1
        if x != sizex - 1 and visited[y][x + 1] == 0:
            options[2] = 1
        if y != 0 and visited[y - 1][x] == 0:
            options[3] = 1

        if options == [0, 0, 0, 0]:
            currentnode = visitn[n - 1]
            x, y = currentnode
            n -= 1
        else:
            while True:
                randomint = random.randint(0, 3)
                if options[randomint] == 1:
                    if randomint == 0:
                        opp = [x - 1, y]
                        Walls[y][x][0] = 0
                        Walls[opp[1]][opp[0]][2] = 0
                    elif randomint == 1:
                        opp = [x, y + 1]
                        Walls[y][x][1] = 0
                        Walls[opp[1]][opp[0]][3] = 0
                    elif randomint == 2:
                        opp = [x + 1, y]
                        Walls[y][x][2] = 0
                        Walls[opp[1]][opp[0]][0] = 0
                    else:
                        opp = [x, y - 1]
                        Walls[y][x][3] = 0
                        Walls[opp[1]][opp[0]][1] = 0

                    n += 1
                    visitn.insert(n, opp)
                    currentnode = opp
                    x, y = currentnode
                    visited[y][x] = 1
                    break

        visitsum = listsum(visited)
    return Walls

def generate_maze(sizex, sizey, wall_config_path=None):
    Walls = mazegenerate(sizex, sizey)
    if wall_config_path:
        try:
            with open(wall_config_path) as f:
                wall_overrides = json.load(f)
            for key, value in wall_overrides.items():
                row, col = map(int, key.split(','))
                Walls[row][col] = value
            print("Custom wall configuration loaded from", wall_config_path)
        except FileNotFoundError:
            print(f"No wall override file found at {wall_config_path}. Using generated maze only.")
    return Walls