import turtle
import pyautogui
import time
from PIL import Image

def draw_maze(sizex, sizey, Walls):
    startx = -380
    starty = -startx
    gridsize = (2 * (-startx)) / sizex
    turtle.clear()
    turtle.speed(0)
    for y in range(sizey):
        for x in range(sizex):
            cell_x = startx + gridsize * x
            cell_y = -starty + gridsize * y
            if Walls[y][x][0] == 1:
                turtle.penup()
                turtle.goto(cell_x, cell_y)
                turtle.pendown()
                turtle.setheading(90)
                turtle.forward(gridsize)
            if Walls[y][x][1] == 1:
                turtle.penup()
                turtle.goto(cell_x, cell_y + gridsize)
                turtle.pendown()
                turtle.setheading(0)
                turtle.forward(gridsize)
            if Walls[y][x][2] == 1:
                turtle.penup()
                turtle.goto(cell_x + gridsize, cell_y)
                turtle.pendown()
                turtle.setheading(90)
                turtle.forward(gridsize)
            if Walls[y][x][3] == 1:
                turtle.penup()
                turtle.goto(cell_x, cell_y)
                turtle.pendown()
                turtle.setheading(0)
                turtle.forward(gridsize)
            turtle.penup()
            turtle.goto(cell_x + gridsize / 2, cell_y + gridsize / 2)
            turtle.pendown()
            turtle.write(f"{y},{x}", align="center", font=("Arial", 10, "normal"))

def save_maze_image(output_eps="maze_output.eps", output_png="maze_generated_output.png"):
    ts = turtle.getscreen()
    canvas = ts.getcanvas()
    canvas.postscript(file=output_eps)
    print(f"Maze image saved as {output_eps}")
    time.sleep(2)
    root = canvas.winfo_toplevel()
    x = root.winfo_rootx()
    y = root.winfo_rooty()
    w = root.winfo_width()
    h = root.winfo_height()
    screenshot = pyautogui.screenshot()
    maze_img = screenshot.crop((x, y, x + w, y + h))
    maze_img.save(output_png)
    print(f"Maze image saved as {output_png}")
    turtle.bye()